import java.util.HashMap;
import java.util.Map;

import javax.jms.Connection;
import javax.jms.MessageConsumer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;

import org.hornetq.api.core.TransportConfiguration;
import org.hornetq.api.jms.HornetQJMSClient;
import org.hornetq.core.remoting.impl.netty.NettyConnectorFactory;
import org.hornetq.core.remoting.impl.netty.TransportConstants;
import org.hornetq.jms.client.HornetQConnectionFactory;

public class HornetQClientReceiver {

	public static void main(String[] args) throws Exception {

		Connection connection = null;
		try {

			Map<String, Object> connectionParams = new HashMap<String, Object>();
			connectionParams.put(TransportConstants.PORT_PROP_NAME, 5545);
			TransportConfiguration transportConfiguration = new TransportConfiguration(
					NettyConnectorFactory.class.getName(), connectionParams);
			HornetQConnectionFactory cf = new HornetQConnectionFactory(false,
					transportConfiguration);
			connection = cf.createConnection();
			Session session = connection.createSession(false,
					Session.AUTO_ACKNOWLEDGE);
			Queue queue = HornetQJMSClient.createQueue("QueueA");
			MessageConsumer messageConsumer = session.createConsumer(queue);
			connection.start();
			TextMessage messageReceived = (TextMessage) messageConsumer
					.receive(5000);
			System.out
					.println("Received message: " + messageReceived.getText());
		} finally {
			if (connection != null) {
				connection.close();
			}
		}
	}
}